Description

Supportanfrage:

Ich habe eine allgemeine Frage bezüglich der Datenübertragung zwischen Filtern mittels IMediaSample in ADTF 2.x.

Wird bei der Übertragung eine Kopie der Daten an den Empfänger übergeben oder wird auf den Speicherbereich verwiesen in dem

die originalen Daten abgelegt sind?

Welche Vorteile bzw. Nachteile bietet die jeweilige Methode?

Lösung:

Beides ist möglich, standardmäßig wird eine Kopie übertragen.

Siehe hierzu das MSF_Reference Flag in der ADTF 2 Doku: MSF_Reference

Vor-/Nachteile können dem DokuLink Pins for Filters: Sending Data entnommen werden:

Warning:

The flag MSF_Reference has to be used with great caution. Its effect is that the data is not copied; instead only a reference to

the external memory is saved in the MediaSample. The data may therefore not be changed as long as the MediaSample has

not yet been deleted!

The MSF_Reference flag was introduced for the optimization of an entire application in order to prevent the repeated copying of

storage ranges. Here it is very important that this is taken into account in the whole application and by all Filters. The use is

unproblematic as long as no Filter buffers this MediaSample. The ADTF default Filters (i.e. QueueRecorder) take this into

account, which create a copy in every case in order to prevent a collision through MSF_Reference. It is important for other

"User" applications that the programmers of Filters that must absolutely use storage references agree with one another.

History

#1 - 2018-07-25 16:04 - hidden

- Subject changed from AW: Please register to Transmission between filterns via IMediaSample in ADTF 2.x 

- Status changed from New to In Progress

- Topic set to ADTF::Streaming

- Customer set to MAN

#2 - 2018-07-26 08:26 - hidden

Hallo André,

Beides ist möglich, aber standardmäßig wird eine Kopie übertragen.

Siehe hierzu das MSF_Reference Flag in der ADTF 2 Doku: MSF_Reference Doku-Link

Gruß,
support.digitalwerk.net/adtf/v2/adtf_sdk_html_docs/classadtf_1_1_i_media_sample.html#ac92024e0e5ad9b1b1e2e1e51ab983dc0a44ac612916847017d4a5ae998dc8bb1f
support.digitalwerk.net/adtf/v2/adtf_sdk_html_docs/page_filter_pins.html#section_sending_data
https://support.digitalwerk.net/adtf/v2/adtf_sdk_html_docs/classadtf_1_1_i_media_sample.html#ac92024e0e5ad9b1b1e2e1e51ab983dc0a44ac612916847017d4a5ae998dc8bb1f


Michael

#3 - 2018-07-26 09:33 - hidden

Hallo André,

sieh dir bitte bzgl. MSF_Reference auch folgende Seite an (insbesondere das Warning): Pins for Filters

Ist deine Anfrage damit beantwortet?

Gruß,

Michael

#4 - 2018-07-27 08:29 - hidden

- Status changed from In Progress to Customer Feedback Required

#5 - 2018-07-27 10:00 - hidden

Hallo Michael,

danke für deine Antwort. Welche Vorteile bzw. Nachteile bietet die jeweilige Methode?

Viele Grüße

André

#6 - 2018-07-27 10:24 - hidden

Hallo André,

zur Frage Vor-/Nachteile konnte ich dem zweiten DokuLink Pins for Filters entnehmen:

Warning:

The flag MSF_Reference has to be used with great caution. Its effect is that the data is not copied; instead only a reference to the external

memory is saved in the MediaSample. The data may therefore not be changed as long as the MediaSample has not yet been deleted!

The MSF_Reference flag was introduced for the optimization of an entire application in order to prevent the repeated copying of storage ranges.

Here it is very important that this is taken into account in the whole application and by all Filters. The use is unproblematic as long as no Filter

buffers this MediaSample. The ADTF default Filters (i.e. QueueRecorder) take this into account, which create a copy in every case in order to

prevent a collision through MSF_Reference. It is important for other "User" applications that the programmers of Filters that must absolutely use

storage references agree with one another.

 Ist deine Anfrage damit beantwortet und wir können das Ticket schließen?

Gruß,

Michael

#7 - 2018-07-27 11:45 - hidden

Vielen Dank, du kannst das Ticket schließen

Viele Grüße

André

#8 - 2018-07-27 15:09 - hidden

- Description updated

- Status changed from Customer Feedback Required to To Be Closed

- Resolution set to Solved Issue

- Affected Products ADTF 2.14.2 added

- Platform Windows 7 64bit added

#9 - 2018-07-31 15:09 - hidden

- Status changed from To Be Closed to Closed

- Private changed from Yes to No
